//+------------------------------------------------------------------+
//|                                               BT_manual_v1.1.mq4 |
//|                           Copyright  2009, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#include <stdlib.mqh>

//---- input parameters
extern string     Expert_Name    = "BT_manual_v1.1";

extern int        Magic                   =    0;    // Magic Number
extern int        StopLossMode            =    1;    // 0-off,1-BT1,2-BT2
extern int        TakeProfitMode          =    0;    // 0-off,1-on
extern int        TrailStopMode           =    1;    // 0-off,1-BT1,2-BT2
extern int        DebugMode               =    0;    // Switch of Debug mode (0-off;1-on) 

extern string     BT1            = "BT1 settings";
extern double     stoch_period            =    9;
extern double     stoch_max               =   53;
extern double     stoch_min               =   47;
extern double     atr_current_norm_factor =0.435;
extern double     atr_before_norm_factor  =  1.5;
extern double     atr_period              =    7;
extern int        atr_before_step         =    1;
extern int        BT1_shift               =    1;

extern string     BT2            = "BT2 settings";
extern int        BT2_shift               =    1;

extern string     ResSup         = "^Pivot_ResSup settings";
extern int        Formula                 =    0;     

//-----
int      TriesNum=5;

double   _Point;
double   minstop;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//---- 
   _Point   = MarketInfo(Symbol(),MODE_POINT)*MathPow(10,Digits%2);
   minstop  = MarketInfo(Symbol(),MODE_STOPLEVEL)/MathPow(10,Digits%2);
//----
   return(0);
}

// ---- Scan Trades
int ScanTrades(int mode)
{   
   int total = OrdersTotal();
   int numords = 0;
   bool type = false; 
   
   
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if (mode == 0) type = OrderType()<=OP_SELLSTOP;
   if (mode == 1) type = OrderType()<=OP_SELL;   
   if (mode == 2) type = OrderType()>OP_SELL && OrderType()<=OP_SELLSTOP; 
   
   if(OrderSymbol() == Symbol() && type && OrderMagicNumber() == Magic)  
   numords++;
   }
   return(numords);
}  

//---- Calculation of Pivots 


double TotalProfit(int type)
{
   int total=OrdersTotal();
   double totalPips = 0;
   double totalProfits = 0;
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();
   bool condition = false;
   if(OrderSymbol() == Symbol())
      if(Magic>0 && OrderMagicNumber() == Magic ) condition = true;
      else 
      if(Magic == 0) condition = true;   
      
      if (condition)
      {      
         switch (mode)
         {
         case OP_BUY:
            totalPips += (MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice())/_Point;
            totalProfits += OrderProfit() + OrderSwap() + OrderCommission();
            break;
            
         case OP_SELL:
            totalPips += (OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_ASK))/_Point;
            totalProfits += OrderProfit() + OrderSwap() + OrderCommission();
            break;
         }
      }            
	}
   if (type == 1) double result = totalPips;
   else result = totalProfits;
   
   return(result);
}

void ChartComment()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";
       
   sComment = sp;
   sComment = sComment+"ExpertName : "+Expert_Name+NL;
   sComment = sComment+"Open Orders= "+ScanTrades(1)+NL;
   sComment = sComment+"Current Profit(pips)= " + DoubleToStr(TotalProfit(1),2) + NL;
   sComment = sComment+"Current Profit("+ AccountCurrency()+") = " + DoubleToStr(TotalProfit(0),2) + NL; 
   sComment = sComment+sp;
   
   Comment(sComment);
}

void TrailStop()
{
   int    error;  
   bool   result=false;
   double BuyStop=0, SellStop=0;
    
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) 
      {
         if (mode==OP_BUY) 
         {
			if(TrailStopMode == 1) BuyStop = iCustom(NULL,0,"BrainTrend1_all_in_one1",stoch_period,stoch_max,stoch_min,atr_current_norm_factor,
			                                        atr_before_norm_factor,atr_period,atr_before_step,1,BT1_shift); 
			if(TrailStopMode == 2) BuyStop = iCustom(NULL,0,"BrainTrend2_all_in_one1",100,false,0,1,BT2_shift);   
			   
			   if(DebugMode > 0) Print("Trailing: BuyStop=",BuyStop);
			   if(BuyStop != EMPTY_VALUE/*&& NormalizeDouble(OrderOpenPrice(),Digits) <= BuyStop*/ ) 
            {   
			      if (BuyStop > NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
			      {
			         for(int k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              BuyStop,
			                              OrderTakeProfit(),0,Lime);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }   		 
               }            
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
         if(TrailStopMode == 1) SellStop = iCustom(NULL,0,"BrainTrend1_all_in_one1",stoch_period,stoch_max,stoch_min,atr_current_norm_factor,
			                                          atr_before_norm_factor,atr_period,atr_before_step,0,BT1_shift);
         if(TrailStopMode == 2) SellStop = iCustom(NULL,0,"BrainTrend2_all_in_one1",100,false,0,0,BT2_shift);  		  
            
            if(DebugMode > 0) Print("Trailing: SellStop=",SellStop);
            if(SellStop != EMPTY_VALUE /*&& NormalizeDouble(OrderOpenPrice(),Digits) >= SellStop && SellStop > 0*/) 
            {
               if(SellStop < NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
               {
                  for( k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              SellStop,
			                              OrderTakeProfit(),0,Orange);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }
               }   
   		   }	    
         }
      }
   }     
}   

void InitialStop()
{
   int    error, np;  
   bool   result=false;
   double BuyStop=0, SellStop=0;
    
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && OrderStopLoss() == 0) 
      {
         if (mode==OP_BUY) 
         {
			if(StopLossMode == 1) BuyStop = iCustom(NULL,0,"BrainTrend1_all_in_one1",stoch_period,stoch_max,stoch_min,atr_current_norm_factor,
			                                        atr_before_norm_factor,atr_period,atr_before_step,5,BT1_shift);
		   if(StopLossMode == 2) BuyStop = iCustom(NULL,0,"BrainTrend2_all_in_one1",100,false,0,5,BT2_shift);
			    
			   if(DebugMode > 0) Print("BuyStop=",BuyStop);
			   
			   if(NormalizeDouble(OrderOpenPrice(),Digits) > BuyStop && BuyStop != EMPTY_VALUE) 
            {   
			      for(int k = 0 ; k < TriesNum; k++)
               {
               result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                           BuyStop,
			                           OrderTakeProfit(),0,Lime);
               error=GetLastError();
                  if(error==0) break;
                  else {Sleep(5000); RefreshRates(); continue;}
               }   		 
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
         if(StopLossMode == 1) SellStop = iCustom(NULL,0,"BrainTrend1_all_in_one1",stoch_period,stoch_max,stoch_min,atr_current_norm_factor,
			                                         atr_before_norm_factor,atr_period,atr_before_step,4,BT1_shift);
         if(StopLossMode == 2) SellStop = iCustom(NULL,0,"BrainTrend2_all_in_one1",100,false,0,4,BT2_shift);
            
            if(DebugMode > 0) Print("SellStop=",SellStop);
         
            if(NormalizeDouble(OrderOpenPrice(),Digits) < SellStop && SellStop != EMPTY_VALUE) 
            {
               for( k = 0 ; k < TriesNum; k++)
               {
               result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                           SellStop,
			                           OrderTakeProfit(),0,Orange);
               error=GetLastError();
                  if(error==0) break;
                  else {Sleep(5000); RefreshRates(); continue;}
               }   
   			}	    
         }
      }
   }     
}   

void TakeProfit()
{
   int    error, np;  
   bool   result=false;
   double BuyProfit=0, SellProfit=0;
    
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic/* && OrderTakeProfit() == 0*/) 
      {
         if (mode==OP_BUY) 
         {
			   BuyProfit = iCustom(NULL,0,"^Pivot_ResSup",Formula,0,0);
			    
			   if(DebugMode > 0) Print("BuyProfit=",BuyProfit);
			   
			   if(NormalizeDouble(OrderOpenPrice(),Digits) < BuyProfit) 
            {   
			      for(int k = 0 ; k < TriesNum; k++)
               {
               result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                           OrderStopLoss(),
			                           BuyProfit,0,Aqua);
               error=GetLastError();
                  if(error==0) break;
                  else {Sleep(5000); RefreshRates(); continue;}
               }   		 
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
         SellProfit = iCustom(NULL,0,"^Pivot_ResSup",Formula,1,0);
         
            if(DebugMode > 0) Print("SellProfit=",SellProfit);
         
            if(NormalizeDouble(OrderOpenPrice(),Digits) > SellProfit) 
            {
               for( k = 0 ; k < TriesNum; k++)
               {
               result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                           OrderStopLoss(),
			                           SellProfit,0,Magenta);
               error=GetLastError();
                  if(error==0) break;
                  else {Sleep(5000); RefreshRates(); continue;}
               }   
   			}	    
         }
      }
   }     
}   



//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(iBars(Symbol(),0) < 100 || IsTradeAllowed()==false) return; 
      
   ChartComment();
   datetime cTime = iTime(Symbol(),0,0);
   
   int Trades = ScanTrades(0);       
   
   if (Trades > 0)
   {
      if(StopLossMode   > 0) InitialStop();
      if(TakeProfitMode > 0) TakeProfit();
      if(TrailStopMode  > 0) TrailStop();
   }      
      
//----
   return(0);
} //start()
//+------------------------------------------------------------------+